OGRE: Ogre::MovableObject Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::MovableObject Class Referenceabstract
Core » Scene

Abstract class defining a movable object in a scene. More...

`#include <OgreMovableObject.h>`

Inheritance diagram for Ogre::MovableObject:
[legend]

## Classes
class | Listener
| Listener which gets called back on MovableObject events. More...

## Public Member Functions
| MovableObject ()
| Constructor.
| MovableObject (const String &name)
| Named constructor.
virtual | ~MovableObject ()
| Virtual destructor - read Scott Meyers if you don't know why this is needed.
MovableObjectFactory * | _getCreator (void) const
| Get the creator of this object, if any (internal use only).
LightList * | _getLightList ()
| Returns a pointer to the current list of lights for this object.
SceneManager * | _getManager (void) const
| Get the manager of this object, if any (internal use only).
virtual const Affine3 & | _getParentNodeFullTransform (void) const
| Return the full transformation of the parent sceneNode or the attachingPoint node.
virtual void | _notifyAttached (Node *parent, bool isTagPoint=false)
| Internal method called to notify the object that it has been attached to a node.
virtual void | _notifyCreator (MovableObjectFactory *fact)
| Notify the object of it's creator (internal use only).
virtual void | _notifyCurrentCamera (Camera *cam)
| Internal method to notify the object of the camera to be used for the next rendering operation.
virtual void | _notifyManager (SceneManager *man)
| Notify the object of it's manager (internal use only).
virtual void | _notifyMoved (void)
| Internal method called to notify the object that it has been moved.
virtual void | _releaseManualHardwareResources ()
| Notifies the movable object that hardware resources were lost.
virtual void | _restoreManualHardwareResources ()
| Notifies the movable object that hardware resources should be restored.
virtual void | _updateRenderQueue (RenderQueue *queue)=0
| Internal method by which the movable object must add Renderable subclass instances to the rendering queue.
void | addQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object.
void | addVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object.
void | detachFromParent (void)
| Detaches an object from a parent SceneNode or TagPoint, if attached.
virtual const AxisAlignedBox & | getBoundingBox (void) const =0
| Retrieves the local axis-aligned bounding box for this object.
virtual Real | getBoundingRadius (void) const =0
| Retrieves the radius of the origin-centered bounding sphere for this object.
Real | getBoundingRadiusScaled () const
| as getBoundingRadius, but with scaling applied
bool | getCastShadows (void) const override
| Returns whether shadow casting is enabled for this object.
uint32 | getLightMask () const
| Get a bitwise mask which will filter the lights affecting this object.
Listener * | getListener (void) const
| Gets the current listener for this object.
virtual const String & | getMovableType (void) const =0
| Returns the type name of this object.
const String & | getName (void) const
| Returns the name of this object.
Node * | getParentNode (void) const
| Returns the node to which this object is attached.
SceneNode * | getParentSceneNode (void) const
| Returns the scene node to which this object is attached.
Real | getPointExtrusionDistance (const Light *l) const override
| Get the distance to extrude for a point/spot light.
virtual uint32 | getQueryFlags (void) const
| Returns the query flags relevant for this object.
bool | getReceivesShadows ()
| Returns whether the Material of any Renderable that this MovableObject will add to the render queue will receive shadows.
Real | getRenderingDistance (void) const
| Gets the distance at which batches are no longer rendered.
Real | getRenderingMinPixelSize () const
| Returns the minimum pixel size an object needs to be in both screen axes in order to be rendered.
uint8 | getRenderQueueGroup (void) const
| Gets the queue group for this entity.
virtual uint32 | getTypeFlags (void) const
| Get the 'type flags' for this MovableObject.
const Any & | getUserAny (void) const
UserObjectBindings & | getUserObjectBindings ()
| Class that provides convenient interface to establish a linkage between custom user application objects and Ogre core classes.
const UserObjectBindings & | getUserObjectBindings () const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual uint32 | getVisibilityFlags (void) const
| Returns the visibility flags relevant for this object.
bool | getVisible (void) const
| Gets this object whether to be visible or not, if it has a renderable component.
const AxisAlignedBox & | getWorldBoundingBox (bool derive=false) const override
| Retrieves the axis-aligned bounding box for this object in world coordinates.
virtual const Sphere & | getWorldBoundingSphere (bool derive=false) const
| Retrieves the worldspace bounding sphere for this object.
bool | isAttached (void) const
| Returns true if this object is attached to a SceneNode or TagPoint.
bool | isDebugDisplayEnabled (void) const
| Gets whether debug display of this object is enabled.
virtual bool | isInScene (void) const
| Returns true if this object is attached to a SceneNode or TagPoint, and this SceneNode / TagPoint is currently in an active part of the scene graph.
bool | isParentTagPoint () const
| Gets whether the parent node is a TagPoint (or a SceneNode).
virtual bool | isVisible (void) const
| Returns whether or not this object is supposed to be visible or not.
const LightList & | queryLights (void) const
| Gets a list of lights, ordered relative to how close they are to this movable object.
void | removeQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object.
void | removeVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object.
void | setCastShadows (bool enabled)
| Sets whether or not this object will cast shadows.
void | setDebugDisplayEnabled (bool enabled)
| Sets whether or not the debug display of this object is enabled.
void | setLightMask (uint32 lightMask)
| Set a bitwise mask which will filter the lights affecting this object.
void | setListener (Listener *listener)
| Sets a listener for this object.
void | setQueryFlags (uint32 flags)
| Sets the query flags for this object.
void | setRenderingDistance (Real dist)
| Sets the distance at which the object is no longer rendered.
void | setRenderingMinPixelSize (Real pixelSize)
| Sets the minimum pixel size an object needs to be in both screen axes in order to be rendered.
virtual void | setRenderQueueGroup (uint8 queueID)
| Sets the render queue group this entity will be rendered through.
virtual void | setRenderQueueGroupAndPriority (uint8 queueID, ushort priority)
| Sets the render queue group and group priority this entity will be rendered through.
void | setUserAny (const Any &anything)
void | setVisibilityFlags (uint32 flags)
| Sets the visibility flags for this object.
void | setVisible (bool visible)
| Tells this object whether to be visible or not, if it has a renderable component.
virtual void | visitRenderables (Renderable::Visitor *visitor, bool debugRenderables=false)=0
| Method to allow a caller to abstractly iterate over the Renderable instances that this MovableObject will add to the render queue when asked, if any.
Public Member Functions inherited from Ogre::ShadowCaster
virtual | ~ShadowCaster ()
const AxisAlignedBox & | getDarkCapBounds (const Light &light, Real dirLightExtrusionDist) const
| Gets the world space bounding box of the dark cap, as extruded using the light provided.
virtual EdgeData * | getEdgeList (void)
| Returns details of the edges which might be used to determine a silhouette.
const AxisAlignedBox & | getLightCapBounds (void) const
| Gets the world space bounding box of the light cap.
virtual const ShadowRenderableList & | getShadowVolumeRenderableList (const Light *light, const HardwareIndexBufferPtr &indexBuffer, size_t &indexBufferUsedSize, float extrusionDistance, int flags=0)
| Gets an list of the renderables required to render the shadow volume.
bool | hasEdgeList ()
| Returns whether the object has a valid edge list.
Public Member Functions inherited from Ogre::AnimableObject
| AnimableObject ()
virtual | ~AnimableObject ()
virtual AnimableValuePtr | createAnimableValue (const String &valueName)
| Create a reference-counted AnimableValuePtr for the named value.
virtual const StringVector & | getAnimableValueNames (void) const
| Gets a list of animable value names for this object.

## Static Public Member Functions
static uint32 | getDefaultQueryFlags ()
| Get the default query flags for all future MovableObject instances.
static uint32 | getDefaultVisibilityFlags ()
| Get the default visibility flags for all future MovableObject instances.
static void | setDefaultQueryFlags (uint32 flags)
| Set the default query flags for all future MovableObject instances.
static void | setDefaultVisibilityFlags (uint32 flags)
| Set the default visibility flags for all future MovableObject instances.
Static Public Member Functions inherited from Ogre::ShadowCaster
static void | clearShadowRenderableList (ShadowRenderableList &shadowRenderables)
| Common implementation of releasing shadow renderables.
static void | extrudeVertices (const HardwareVertexBufferSharedPtr &vertexBuffer, size_t originalVertexCount, const Vector4 &lightPos, Real extrudeDist)
| Utility method for extruding vertices based on a light.

## Additional Inherited Members
Public Types inherited from Ogre::ShadowCaster
typedef Ogre::ShadowRenderableList | ShadowRenderableList
typedef VectorIterator< ShadowRenderableList > | ShadowRenderableListIterator

## Detailed Description

Abstract class defining a movable object in a scene.

Instances of this class are discrete, relatively small, movable objects which are attached to SceneNode objects to define their position.

## Constructor & Destructor Documentation

## ◆ MovableObject() [1/2]

Ogre::MovableObject::MovableObject | ( |  | ) |

Constructor.

Referenced by Ogre::Entity::attachObjectToBone(), Ogre::Entity::detachObjectFromBone(), Ogre::Entity::detachObjectFromBone(), Ogre::MovableObject::Listener::objectAttached(), Ogre::MovableObject::Listener::objectDestroyed(), Ogre::MovableObject::Listener::objectDetached(), Ogre::MovableObject::Listener::objectMoved(), Ogre::MovableObject::Listener::objectQueryLights(), and Ogre::MovableObject::Listener::objectRendering().

## ◆ MovableObject() [2/2]

Ogre::MovableObject::MovableObject | ( | const String & | name | ) |

Named constructor.

## ◆ ~MovableObject()

virtual Ogre::MovableObject::~MovableObject | ( |  | ) |
| virtual

Virtual destructor - read Scott Meyers if you don't know why this is needed.

## Member Function Documentation

## ◆ _notifyCreator()

virtual void Ogre::MovableObject::_notifyCreator | ( | MovableObjectFactory * | fact | ) |
| inlinevirtual

Notify the object of it's creator (internal use only).

## ◆ _getCreator()

MovableObjectFactory * Ogre::MovableObject::_getCreator | ( | void |  | ) | const
| inline

Get the creator of this object, if any (internal use only).

## ◆ _notifyManager()

virtual void Ogre::MovableObject::_notifyManager | ( | SceneManager * | man | ) |
| inlinevirtual

Notify the object of it's manager (internal use only).

## ◆ _getManager()

SceneManager * Ogre::MovableObject::_getManager | ( | void |  | ) | const
| inline

Get the manager of this object, if any (internal use only).

## ◆ _releaseManualHardwareResources()

virtual void Ogre::MovableObject::_releaseManualHardwareResources | ( |  | ) |
| inlinevirtual

Notifies the movable object that hardware resources were lost.

Called automatically by RenderSystem if hardware resources were lost and can not be restored using some internal mechanism. Among affected resources are nested shadow renderables, ManualObjects, etc.

Reimplemented in Ogre::BillboardSet, Ogre::Entity, Ogre::ManualObject, and Ogre::StaticGeometry::Region.

## ◆ _restoreManualHardwareResources()

virtual void Ogre::MovableObject::_restoreManualHardwareResources | ( |  | ) |
| inlinevirtual

Notifies the movable object that hardware resources should be restored.

Called automatically by RenderSystem if hardware resources were lost and can not be restored using some internal mechanism. Among affected resources are nested shadow renderables, ManualObjects, etc.

Reimplemented in Ogre::Entity, and Ogre::StaticGeometry::Region.

## ◆ getName()

const String & Ogre::MovableObject::getName | ( | void |  | ) | const
| inline

Returns the name of this object.

## ◆ getMovableType()

virtual const String & Ogre::MovableObject::getMovableType | ( | void |  | ) | const
| pure virtual

Returns the type name of this object.

Implemented in Ogre::AntiPortal, Ogre::BillboardChain, Ogre::BillboardSet, Ogre::Camera, Ogre::Entity, Ogre::Frustum, Ogre::InstanceBatch, Ogre::InstancedEntity, Ogre::Light, Ogre::ManualObject, Ogre::MovablePlane, Ogre::ParticleSystem, Ogre::PCZLight, Ogre::Portal, Ogre::Rectangle2D, Ogre::RibbonTrail, Ogre::SimpleRenderable, Ogre::StaticGeometry::Region, and Ogre::Volume::Chunk.

## ◆ getParentNode()

Node * Ogre::MovableObject::getParentNode | ( | void |  | ) | const
| inline

Returns the node to which this object is attached.

A MovableObject may be attached to either a SceneNode or to a TagPoint, the latter case if it's attached to a bone on an animated entity. Both are Node subclasses so this method will return either.

## ◆ getParentSceneNode()

SceneNode * Ogre::MovableObject::getParentSceneNode | ( | void |  | ) | const

Returns the scene node to which this object is attached.

A MovableObject may be attached to either a SceneNode or to a TagPoint, the latter case if it's attached to a bone on an animated entity. This method will return the scene node of the parent entity if the latter is true.

## ◆ isParentTagPoint()

bool Ogre::MovableObject::isParentTagPoint | ( |  | ) | const
| inline

Gets whether the parent node is a TagPoint (or a SceneNode).

## ◆ _notifyAttached()

virtual void Ogre::MovableObject::_notifyAttached | ( | Node * | parent,
|  | bool | isTagPoint = false )
| virtual

Internal method called to notify the object that it has been attached to a node.

Reimplemented in Ogre::Entity, Ogre::InstancedEntity, Ogre::Light, Ogre::ParticleSystem, and Ogre::PortalBase.

Referenced by Ogre::PortalBase::_notifyAttached().

## ◆ isAttached()

bool Ogre::MovableObject::isAttached | ( | void |  | ) | const
| inline

Returns true if this object is attached to a SceneNode or TagPoint.

## ◆ detachFromParent()

void Ogre::MovableObject::detachFromParent | ( | void |  | ) |

Detaches an object from a parent SceneNode or TagPoint, if attached.

## ◆ isInScene()

virtual bool Ogre::MovableObject::isInScene | ( | void |  | ) | const
| virtual

Returns true if this object is attached to a SceneNode or TagPoint, and this SceneNode / TagPoint is currently in an active part of the scene graph.

Reimplemented in Ogre::InstancedEntity.

## ◆ _notifyMoved()

virtual void Ogre::MovableObject::_notifyMoved | ( | void |  | ) |
| virtual

Internal method called to notify the object that it has been moved.

Reimplemented in Ogre::InstancedEntity, Ogre::Light, Ogre::PCZLight, and Ogre::PortalBase.

## ◆ _notifyCurrentCamera()

virtual void Ogre::MovableObject::_notifyCurrentCamera | ( | Camera * | cam | ) |
| virtual

Internal method to notify the object of the camera to be used for the next rendering operation.

Certain objects may want to do specific processing based on the camera position. This method notifies them in case they wish to do this.

Reimplemented in Ogre::BillboardSet, Ogre::Entity, Ogre::Frustum, Ogre::InstanceBatch, Ogre::MovablePlane, Ogre::ParticleSystem, Ogre::SimpleRenderable, and Ogre::StaticGeometry::Region.

## ◆ getBoundingBox()

virtual const AxisAlignedBox & Ogre::MovableObject::getBoundingBox | ( | void |  | ) | const
| pure virtual

Retrieves the local axis-aligned bounding box for this object.

This bounding box is in local coordinates.

Implemented in Ogre::BillboardChain, Ogre::BillboardSet, Ogre::Entity, Ogre::Frustum, Ogre::InstanceBatch, Ogre::InstancedEntity, Ogre::Light, Ogre::ManualObject, Ogre::MovablePlane, Ogre::ParticleSystem, Ogre::PCZCamera, Ogre::PortalBase, Ogre::SimpleRenderable, Ogre::StaticGeometry::Region, and Ogre::TerrainQuadTreeNode.

## ◆ getBoundingRadius()

virtual Real Ogre::MovableObject::getBoundingRadius | ( | void |  | ) | const
| pure virtual

Retrieves the radius of the origin-centered bounding sphere for this object.

Implemented in Ogre::BillboardChain, Ogre::BillboardSet, Ogre::Camera, Ogre::Entity, Ogre::Frustum, Ogre::InstanceBatch, Ogre::InstancedEntity, Ogre::Light, Ogre::ManualObject, Ogre::MovablePlane, Ogre::ParticleSystem, Ogre::PortalBase, Ogre::Rectangle2D, Ogre::StaticGeometry::Region, Ogre::TerrainQuadTreeNode, Ogre::Volume::Chunk, and Ogre::WireBoundingBox.

## ◆ getBoundingRadiusScaled()

Real Ogre::MovableObject::getBoundingRadiusScaled | ( |  | ) | const

as getBoundingRadius, but with scaling applied

## ◆ getWorldBoundingBox()

const AxisAlignedBox & Ogre::MovableObject::getWorldBoundingBox | ( | bool | derive = false | ) | const
| overridevirtual

Retrieves the axis-aligned bounding box for this object in world coordinates.

Implements Ogre::ShadowCaster.

Reimplemented in Ogre::PortalBase.

## ◆ getWorldBoundingSphere()

virtual const Sphere & Ogre::MovableObject::getWorldBoundingSphere | ( | bool | derive = false | ) | const
| virtual

Retrieves the worldspace bounding sphere for this object.

Reimplemented in Ogre::Entity, and Ogre::PortalBase.

## ◆ _updateRenderQueue()

virtual void Ogre::MovableObject::_updateRenderQueue | ( | RenderQueue * | queue | ) |
| pure virtual

Internal method by which the movable object must add Renderable subclass instances to the rendering queue.

The engine will call this method when this object is to be rendered. The object must then create one or more Renderable subclass instances which it places on the passed in Queue for rendering.

Implemented in Ogre::BaseInstanceBatchVTF, Ogre::BillboardChain, Ogre::BillboardSet, Ogre::Entity, Ogre::Frustum, Ogre::InstanceBatch, Ogre::InstanceBatchHW, Ogre::InstanceBatchHW_VTF, Ogre::InstancedEntity, Ogre::Light, Ogre::ManualObject, Ogre::MovablePlane, Ogre::ParticleSystem, Ogre::PortalBase, Ogre::SimpleRenderable, and Ogre::StaticGeometry::Region.

## ◆ setVisible()

void Ogre::MovableObject::setVisible | ( | bool | visible | ) |
| inline

Tells this object whether to be visible or not, if it has a renderable component.

Note
  An alternative approach of making an object invisible is to detach it from it's SceneNode, or to remove the SceneNode entirely. Detaching a node means that structurally the scene graph changes. Once this change has taken place, the objects / nodes that have been removed have less overhead to the visibility detection pass than simply making the object invisible, so if you do this and leave the objects out of the tree for a long time, it's faster. However, the act of detaching / reattaching nodes is in itself more expensive than setting an object visibility flag, since in the latter case structural changes are not made. Therefore, small or frequent visibility changes are best done using this method; large or more longer term changes are best done by detaching.

Referenced by Ogre::Light::setVisible().

## ◆ getVisible()

bool Ogre::MovableObject::getVisible | ( | void |  | ) | const
| inline

Gets this object whether to be visible or not, if it has a renderable component.

Returns the value set by MovableObject::setVisible only.

## ◆ isVisible()

virtual bool Ogre::MovableObject::isVisible | ( | void |  | ) | const
| virtual

Returns whether or not this object is supposed to be visible or not.

Takes into account both upper rendering distance and visible flag.

Reimplemented in Ogre::Frustum, and Ogre::StaticGeometry::Region.

Referenced by Ogre::Frustum::getFrustumPlane().

## ◆ setRenderingDistance()

void Ogre::MovableObject::setRenderingDistance | ( | Real | dist | ) |
| inline

Sets the distance at which the object is no longer rendered.

Note
  Camera::setUseRenderingDistance() needs to be called for this parameter to be used.

Parameters

  dist | Distance beyond which the object will not be rendered (the default is 0, which means objects are always rendered).

## ◆ getRenderingDistance()

Real Ogre::MovableObject::getRenderingDistance | ( | void |  | ) | const
| inline

Gets the distance at which batches are no longer rendered.

## ◆ setRenderingMinPixelSize()

void Ogre::MovableObject::setRenderingMinPixelSize | ( | Real | pixelSize | ) |
| inline

Sets the minimum pixel size an object needs to be in both screen axes in order to be rendered.

Note
  Camera::setUseMinPixelSize() needs to be called for this parameter to be used.

Parameters

  pixelSize | Number of minimum pixels (the default is 0, which means objects are always rendered).

## ◆ getRenderingMinPixelSize()

Real Ogre::MovableObject::getRenderingMinPixelSize | ( |  | ) | const
| inline

Returns the minimum pixel size an object needs to be in both screen axes in order to be rendered.

## ◆ setUserAny()

void Ogre::MovableObject::setUserAny | ( | const Any & | anything | ) |
| inline

Deprecated
  use UserObjectBindings::setUserAny via getUserObjectBindings() instead.

References getUserObjectBindings().

## ◆ getUserAny()

const Any & Ogre::MovableObject::getUserAny | ( | void |  | ) | const
| inline

Deprecated
  use UserObjectBindings::getUserAny via getUserObjectBindings() instead.

References getUserObjectBindings().

## ◆ getUserObjectBindings() [1/2]

UserObjectBindings & Ogre::MovableObject::getUserObjectBindings | ( |  | ) |
| inline

Class that provides convenient interface to establish a linkage between custom user application objects and Ogre core classes.

Referenced by getUserAny(), and setUserAny().

## ◆ getUserObjectBindings() [2/2]

const UserObjectBindings & Ogre::MovableObject::getUserObjectBindings | ( |  | ) | const
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ setRenderQueueGroup()

virtual void Ogre::MovableObject::setRenderQueueGroup | ( | uint8 | queueID | ) |
| virtual

Sets the render queue group this entity will be rendered through.

Render queues are grouped to allow you to more tightly control the ordering of rendered objects. If you do not call this method, all Entity objects default to the default queue (RenderQueue::getDefaultQueueGroup), which is fine for most objects. You may want to alter this if you want this entity to always appear in front of other objects, e.g. for a 3D menu system or such.

  See RenderQueue for more details.

Parameters

  queueID | Enumerated value of the queue group to use. See the enum RenderQueueGroupID for what kind of values can be used here.

Reimplemented in Ogre::Entity, and Ogre::ParticleSystem.

## ◆ setRenderQueueGroupAndPriority()

virtual void Ogre::MovableObject::setRenderQueueGroupAndPriority | ( | uint8 | queueID,
|  | ushort | priority )
| virtual

Sets the render queue group and group priority this entity will be rendered through.

Render queues are grouped to allow you to more tightly control the ordering of rendered objects. Within a single render group there another type of grouping called priority which allows further control. If you do not call this method, all Entity objects default to the default queue and priority (RenderQueue::getDefaultQueueGroup, RenderQueue::getDefaultRenderablePriority), which is fine for most objects. You may want to alter this if you want this entity to always appear in front of other objects, e.g. for a 3D menu system or such.

  See RenderQueue for more details.

Parameters

  queueID | Enumerated value of the queue group to use. See the enum RenderQueueGroupID for what kind of values can be used here.
  priority | The priority within a group to use.

Reimplemented in Ogre::Entity, and Ogre::ParticleSystem.

## ◆ getRenderQueueGroup()

uint8 Ogre::MovableObject::getRenderQueueGroup | ( | void |  | ) | const
| inline

Gets the queue group for this entity.

See also
  setRenderQueueGroup

## ◆ _getParentNodeFullTransform()

virtual const Affine3 & Ogre::MovableObject::_getParentNodeFullTransform | ( | void |  | ) | const
| virtual

Return the full transformation of the parent sceneNode or the attachingPoint node.

Reimplemented in Ogre::InstancedEntity.

## ◆ setQueryFlags()

void Ogre::MovableObject::setQueryFlags | ( | uint32 | flags | ) |
| inline

Sets the query flags for this object.

When performing a scene query, this object will be included or excluded according to flags on the object and flags on the query. This is a bitwise value, so only when a bit on these flags is set, will it be included in a query asking for that flag. The meaning of the bits is application-specific.

## ◆ addQueryFlags()

void Ogre::MovableObject::addQueryFlags | ( | uint32 | flags | ) |
| inline

As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object.

## ◆ removeQueryFlags()

void Ogre::MovableObject::removeQueryFlags | ( | uint32 | flags | ) |
| inline

As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object.

## ◆ getQueryFlags()

virtual uint32 Ogre::MovableObject::getQueryFlags | ( | void |  | ) | const
| inlinevirtual

Returns the query flags relevant for this object.

## ◆ setDefaultQueryFlags()

void Ogre::MovableObject::setDefaultQueryFlags | ( | uint32 | flags | ) |
| inlinestatic

Set the default query flags for all future MovableObject instances.

## ◆ getDefaultQueryFlags()

uint32 Ogre::MovableObject::getDefaultQueryFlags | ( |  | ) |
| inlinestatic

Get the default query flags for all future MovableObject instances.

## ◆ setVisibilityFlags()

void Ogre::MovableObject::setVisibilityFlags | ( | uint32 | flags | ) |
| inline

Sets the visibility flags for this object.

As well as a simple true/false value for visibility (as seen in setVisible), you can also set visibility flags which when 'and'ed with the SceneManager's visibility mask can also make an object invisible.

## ◆ addVisibilityFlags()

void Ogre::MovableObject::addVisibilityFlags | ( | uint32 | flags | ) |
| inline

As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object.

## ◆ removeVisibilityFlags()

void Ogre::MovableObject::removeVisibilityFlags | ( | uint32 | flags | ) |
| inline

As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object.

## ◆ getVisibilityFlags()

virtual uint32 Ogre::MovableObject::getVisibilityFlags | ( | void |  | ) | const
| inlinevirtual

Returns the visibility flags relevant for this object.

## ◆ setDefaultVisibilityFlags()

void Ogre::MovableObject::setDefaultVisibilityFlags | ( | uint32 | flags | ) |
| inlinestatic

Set the default visibility flags for all future MovableObject instances.

## ◆ getDefaultVisibilityFlags()

uint32 Ogre::MovableObject::getDefaultVisibilityFlags | ( |  | ) |
| inlinestatic

Get the default visibility flags for all future MovableObject instances.

## ◆ setListener()

void Ogre::MovableObject::setListener | ( | Listener * | listener | ) |
| inline

Sets a listener for this object.

Note for size and performance reasons only one listener per object is allowed.

## ◆ getListener()

Listener * Ogre::MovableObject::getListener | ( | void |  | ) | const
| inline

Gets the current listener for this object.

## ◆ queryLights()

const LightList & Ogre::MovableObject::queryLights | ( | void |  | ) | const

Gets a list of lights, ordered relative to how close they are to this movable object.

By default, this method gives the listener a chance to populate light list first, if there is no listener or Listener::objectQueryLights returns NULL, it'll query the light list from parent entity if it is present, or returns SceneNode::findLights if it has parent scene node, otherwise it just returns an empty list.

  The object internally caches the light list, so it will recalculate it only when object is moved, or lights that affect the frustum have been changed (

See also
  SceneManager::_getLightsDirtyCounter), but if listener exists, it will be called each time, so the listener should implement their own cache mechanism to optimise performance.

  This method can be useful when implementing Renderable::getLights in case the renderable is a part of the movable.

Returns
  The list of lights use to lighting this object.

## ◆ getLightMask()

uint32 Ogre::MovableObject::getLightMask | ( |  | ) | const
| inline

Get a bitwise mask which will filter the lights affecting this object.

By default, this mask is fully set meaning all lights will affect this object

## ◆ setLightMask()

void Ogre::MovableObject::setLightMask | ( | uint32 | lightMask | ) |

Set a bitwise mask which will filter the lights affecting this object.

This mask will be compared against the mask held against Light to determine if a light should affect a given object. By default, this mask is fully set meaning all lights will affect this object

## ◆ _getLightList()

LightList * Ogre::MovableObject::_getLightList | ( |  | ) |
| inline

Returns a pointer to the current list of lights for this object.

You should not modify this list outside of MovableObject::Listener::objectQueryLights (say if you want to use it to implement this method, and use the pointer as a return value) and for reading it's only accurate as at the last frame.

## ◆ setCastShadows()

void Ogre::MovableObject::setCastShadows | ( | bool | enabled | ) |
| inline

Sets whether or not this object will cast shadows.

This setting simply allows you to turn on/off shadows for a given object. An object will not cast shadows unless the scene supports it in any case (see SceneManager::setShadowTechnique), and also the material which is in use must also have shadow casting enabled. By default all entities cast shadows. If, however, for some reason you wish to disable this for a single object then you can do so using this method.

Note
  This method normally refers to objects which block the light, but since Light is also a subclass of MovableObject, in that context it means whether the light causes shadows itself.

## ◆ getCastShadows()

bool Ogre::MovableObject::getCastShadows | ( | void |  | ) | const
| inlineoverridevirtual

Returns whether shadow casting is enabled for this object.

Implements Ogre::ShadowCaster.

## ◆ getReceivesShadows()

bool Ogre::MovableObject::getReceivesShadows | ( |  | ) |

Returns whether the Material of any Renderable that this MovableObject will add to the render queue will receive shadows.

## ◆ getPointExtrusionDistance()

Real Ogre::MovableObject::getPointExtrusionDistance | ( | const Light * | l | ) | const
| overridevirtual

Get the distance to extrude for a point/spot light.

Implements Ogre::ShadowCaster.

## ◆ getTypeFlags()

virtual uint32 Ogre::MovableObject::getTypeFlags | ( | void |  | ) | const
| virtual

Get the 'type flags' for this MovableObject.

A type flag identifies the type of the MovableObject as a bitpattern. This is used for categorical inclusion / exclusion in SceneQuery objects. By default, this method returns all ones for objects not created by a MovableObjectFactory (hence always including them); otherwise it returns the value assigned to the MovableObjectFactory. Custom objects which don't use MovableObjectFactory will need to override this if they want to be included in queries.

Reimplemented in Ogre::BillboardSet, Ogre::Entity, Ogre::Frustum, Ogre::Light, Ogre::ParticleSystem, and Ogre::StaticGeometry::Region.

## ◆ visitRenderables()

virtual void Ogre::MovableObject::visitRenderables | ( | Renderable::Visitor * | visitor,
|  | bool | debugRenderables = false )
| pure virtual

Method to allow a caller to abstractly iterate over the Renderable instances that this MovableObject will add to the render queue when asked, if any.

Parameters

  visitor | Pointer to a class implementing the Renderable::Visitor interface which will be called back for each Renderable which will be queued. Bear in mind that the state of the Renderable instances may not be finalised depending on when you call this.
  debugRenderables | If false, only regular renderables will be visited (those for normal display). If true, debug renderables will be included too.

Implemented in Ogre::BillboardChain, Ogre::BillboardSet, Ogre::Entity, Ogre::Frustum, Ogre::InstanceBatch, Ogre::InstancedEntity, Ogre::Light, Ogre::ManualObject, Ogre::MovablePlane, Ogre::ParticleSystem, Ogre::PortalBase, Ogre::SimpleRenderable, and Ogre::StaticGeometry::Region.

## ◆ setDebugDisplayEnabled()

void Ogre::MovableObject::setDebugDisplayEnabled | ( | bool | enabled | ) |
| inline

Sets whether or not the debug display of this object is enabled.

Some objects aren't visible themselves but it can be useful to display a debug representation of them. Or, objects may have an additional debug display on top of their regular display. This option enables / disables that debug display. Objects that are not visible never display debug geometry regardless of this setting.

## ◆ isDebugDisplayEnabled()

bool Ogre::MovableObject::isDebugDisplayEnabled | ( | void |  | ) | const
| inline

Gets whether debug display of this object is enabled.

The documentation for this class was generated from the following file:

- OgreMovableObject.h